unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Gauges, Menus;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuExit: TMenuItem;
    MenuMisc: TMenuItem;
    MenuInfo: TMenuItem;
    MenuStayOnTop: TMenuItem;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Memo2: TMemo;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Gauge1: TGauge;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuStayOnTopClick(Sender: TObject);
  private

  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    fjutil, Jconvert, Info;

var
    Work: TStringList;

//  ---------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    FBox.SetCaption(Self);
end;

//  ---------------------------------------------------------------------------
//  w肵URL̃\[X擾
function    GetPage(const URL: string; Page: TStrings; EncUtf8: Boolean = false): Boolean;
var
    S: TMemoryStream;
begin
    Result := false;
    S :=TMemoryStream.Create;
    S.Position := 0;
    try
        try
            //  y[Wǂݍ
            INet.GetHtmlFile(S, URL);
            //  ݈ʒuŏɖ߂
            S.Position := 0;
            //  񃊃Xgɓ]L
            Page.LoadFromStream(S);

            //  UTF8ŁH
            if EncUtf8 then
            begin
                Page.Text := Utf8ToAnsi(Page.Text);
            end
            //  ႤH
            else
            begin
                Page.Text := ConvertJCode(Page.Text, SJIS_OUT);
            end;

            //  Ƃ肠Ō܂ł
            Result := true;
        finally
            S.Free;
        end;
    except
        ;
    end;
end;

//  ---------------------------------------------------------------------------
//  HTML̃^Cg擾
function    GetTitle(Page: TStrings): string;
var
    i, Temp: integer;
    Line: string;
    Found: Boolean;
begin
    Result := '';
    Work.Clear;

    //  oCiȂ瑦
    if (InCodeCheck(Page.Text) = BINARY) then exit;

    //  </title>̂s
    Found := false;
    for i := 0 to Page.Count - 1 do
    begin
        Line := Page[i];
        Found := AnsiPos('</title>', LowerCase(Line)) > 0;
        Work.Add(Line);
        if (Found) then break;
    end;
    //  ꍇA̍s^Cgo
    if (Found) then
    begin
        //  </title> ܂ލsȑȎSĂ̍s̉s΂
        Line := Work.Text;
        Line := StringReplace(Line, #13#10, '', [rfReplaceAll]);
        //  </title> ȍ~̕폜
        Temp := AnsiPos('</title>', LowerCase(Line));
        Line := Copy(Line, 1, Temp - 1);
        //  ɂɊ܂܂Ō>(<title...>̃Pc)ȑO폜
        Temp := LastDelimiter('>', Line);
        //  炻ȍ~^Cg
        //  Ȃ΂ꂪ^Cg
        if (Temp > 0) then Line := Copy(Line, Temp + 1, Length(Line));

        Result := Line;
    end;
end;

//  ---------------------------------------------------------------------------
//  HREF쐬
function    BuildHref(const URL, Title: string): string;
const
    FMT = '<a target="link" href="%s">%s</a>';
var
    T: string;
begin
    //  ^CgȂ΁AURLőp
    if (Title = '') then T := URL else T := Title;
    //  
    Result := Format(FMT, [URL, T]); 
end;

//  ---------------------------------------------------------------------------
//  ܂t
function    DecorateTag(const S: string): string;
var
    S1: string;
begin
    S1 := FormatDateTime(':[yyyy/mm/dd]', Now);
    Result := Format('%s%s%s', ['<li>', S, S1]);
end;    

//  ---------------------------------------------------------------------------
//  s
procedure TMainForm.BitBtn1Click(Sender: TObject);
var
    i: integer;
    URL, Title, Tag: string;
    Page: TStrings;
begin
    if not CheckBox2.Checked then Memo2.Clear;
    Page := TStringList.Create;

    Gauge1.MaxValue := Memo1.Lines.Count;
    Gauge1.Progress := 0;

    for i := 0 to Memo1.Lines.Count - 1 do
    begin
        //  URLo
        URL := Trim(Memo1.Lines[i]);
        //  s͔΂
        if (Trim(StringReplace(URL, '@', ' ', [rfReplaceAll])) = '') then continue;
        //  N璆~
        if not GetPage(URL, Page, CheckBox1.Checked) then continue;
        //  ^Cgo
        Title := GetTitle(Page);
        //  N^O쐬
        Tag := BuildHref(URL, Title);
        //  ǉ
        Memo2.Lines.Add(DecorateTag(Tag));

        Gauge1.AddProgress(1);
    end;
    Sleep(100);
    Gauge1.Progress := 0;

    Page.Free;
    Memo2.SetFocus;
    Memo2.SelectAll;
end;

procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

procedure TMainForm.MenuStayOnTopClick(Sender: TObject);
begin
    if (MenuStayOnTop.Checked) then
        Self.FormStyle := fsStayOnTop
    else
        Self.FormStyle := fsNormal;
end;

initialization
    Work := TStringList.Create;
finalization
    Work.Free;
end.

